// ProductRecord.H : Declaration of the CProductRecord class

#ifndef __PRODUCTRECORD_H_
#define __PRODUCTRECORD_H_

#include <comdef.h>

//##ModelId=37DC44070000
class CProductRecordAccessor
{
public:
	//##ModelId=37DC44070045
	LONG m_SKU;
	//##ModelId=37DC44070044
	TCHAR m_COMPOSER[21];
	//##ModelId=37DC44070043
	TCHAR m_COMPOSITION[51];
	//##ModelId=37DC44070042
	TCHAR m_CONDUCTOR[51];
	//##ModelId=37DC44070041
	TCHAR m_PERFORMER[51];
	//##ModelId=37DC44070040
	TCHAR m_DESCRIPTION[256];
	//##ModelId=37DC4407003F
	TCHAR m_IMAGE[31];
	//##ModelId=37DC4407003E
	float m_PRICE;
	//##ModelId=37DC4407003D
	LONG m_ONHAND;
	//##ModelId=37DC4407003C
	LONG m_REORDERLEVEL;

BEGIN_COLUMN_MAP(CProductRecordAccessor)
COLUMN_ENTRY(1, m_SKU)	
COLUMN_ENTRY(2, m_COMPOSER)	
COLUMN_ENTRY(3, m_COMPOSITION)	
COLUMN_ENTRY(4, m_CONDUCTOR)	
COLUMN_ENTRY(5, m_PERFORMER)	
COLUMN_ENTRY(6, m_DESCRIPTION)	
COLUMN_ENTRY(7, m_IMAGE)	
COLUMN_ENTRY(8, m_PRICE)	
COLUMN_ENTRY(9, m_ONHAND)	
COLUMN_ENTRY(10, m_REORDERLEVEL)
END_COLUMN_MAP()

DEFINE_COMMAND(CProductRecordAccessor, _T(" \
	SELECT \
		* \
		FROM PRODUCTS"))

	// You may wish to call this function if you are inserting a record and wish to
	// initialize all the fields, if you are not going to explicitly set all of them.
	//##ModelId=37DC44070046
	void ClearRecord()
	{
		memset(this, 0, sizeof(*this));
	}
};

//##ModelId=37DC4406030C
class CProductRecord : public CCommand<CAccessor<CProductRecordAccessor> >
{
public:
	//##ModelId=37DC44060381
	long m_sku;

	//##ModelId=37DC44060385
	HRESULT OpenProduct( long sku )
	{		
		m_sku = sku;		
		return Open();	
	}

	//##ModelId=37DC44060384
	HRESULT Open()
	{
		HRESULT		hr;

		hr = OpenDataSource();
		if (FAILED(hr))
			return hr;

		return OpenRowset();
	}
	//##ModelId=37DC44060383
	HRESULT OpenDataSource()
	{
		HRESULT		hr;
		CDataSource db;
		CDBPropSet	dbinit(DBPROPSET_DBINIT);

		dbinit.AddProperty(DBPROP_AUTH_PERSIST_SENSITIVE_AUTHINFO, false);
		dbinit.AddProperty(DBPROP_INIT_DATASOURCE, OLESTR("ClassicsPOSServer"));
		dbinit.AddProperty(DBPROP_INIT_PROMPT, (short)4);
		dbinit.AddProperty(DBPROP_INIT_LCID, (long)1033);
		hr = db.Open(_T("MSDASQL"), &dbinit);
		if (FAILED(hr))
			return hr;

		return m_session.Open(db);
	}
	//##ModelId=37DC44060382
	HRESULT OpenRowset()
	{
		_bstr_t sql;		
		char idbuf[10];		

		// Set properties for open
		CDBPropSet	propset(DBPROPSET_ROWSET);
		propset.AddProperty(DBPROP_IRowsetChange, true);
		propset.AddProperty(DBPROP_UPDATABILITY, DBPROPVAL_UP_CHANGE | DBPROPVAL_UP_INSERT | DBPROPVAL_UP_DELETE);

		sql = "SELECT * FROM PRODUCTS WHERE SKU=";		
		ltoa(m_sku,idbuf,10);		
		sql += idbuf;		

		return CCommand<CAccessor<CProductRecordAccessor> >::Open(m_session, NULL, &propset);
	}
	//##ModelId=37DC4406037E
	CSession	m_session;
};

#endif // __PRODUCTRECORD_H_
